﻿;==================================================================================================
;AUTHOR   : https://www.xyplorer.com/xyfc/viewtopic.php?t=25763
;Function : XYplorer 4 custom queue menus
;Created  : 2023-02-28
;Modified : 2023-03-20
;Version  : v1.4Q
;==================================================================================================
#Requires AutoHotkey v2.0.2
#HotIf MouseIsOver("ahk_class Progman") || MouseIsOver("ahk_class WorkerW") || MouseIsOver("ahk_class CabinetWClass") || MouseIsOver("ahk_class ThunderRT6FormDC")


MouseIsOver(WinTitle) {
    MouseGetPos ,, &Win
	return WinExist(WinTitle " ahk_id " Win)
}


; Get our own HWND (we have no visible window)
DetectHiddenWindows(true)
G_OwnHWND := WinExist("Ahk_PID " DllCall("GetCurrentProcessId"))
G_OwnHWND += 0


; Get messages back from XYplorer
OnMessage(0x4a, Receive_WM_COPYDATA)

xyPath  := "D:\XYplorer\XYplorer.exe"      ; XY path
if !FileExist(xyPath)
{
   msgbox "XYplorer path does not exist!`n`n" xyPath
   ExitApp
}

exHwnd  := ""
global selMenu:="", selPos:="", selItem:="", IDLast:=""






;==================================================================================================
; Dark theme
;==================================================================================================

; Dark mode (Required Windows 10 version)
uxtheme := DllCall("GetModuleHandle", "str", "uxtheme", "ptr")
SetPreferredAppMode := DllCall("GetProcAddress", "ptr", uxtheme, "ptr", 135, "ptr")
FlushMenuThemes := DllCall("GetProcAddress", "ptr", uxtheme, "ptr", 136, "ptr")
DllCall(SetPreferredAppMode, "int", 1) ; Dark
DllCall(FlushMenuThemes)

; Switch from dark to not dark
/*
DllCall(SetPreferredAppMode, "int", 0) ; NOT Dark
DllCall(FlushMenuThemes)
*/



;==================================================================================================
; Create a popup menu
;==================================================================================================

; Create main menu
 MyMenu := Menu()
 MyMenu.Name := "Main menu"                                   ; Used to show which menu is selected

;  Add menu item
 MyMenu.Add "Item 1111", MenuHandler

 if FileExist(xyPath)
    MyMenu.SetIcon("Item 1111", xyPath)               ; Add icon to first menu item if icon file exists

 MyMenu.Add "Item 2222", MenuHandler                          ; Add a second menu item
 MyMenu.Add                                                   ; Add a separator line


; Add submenu
 Submenu1 := Menu()
 Submenu1.Name := "Submenu4"                              ; Used to show which menu is selected
; Add items to submenu
 Submenu1.Add "Submenu item 1111", MenuHandler
 Submenu1.Add "Submenu item 2222", MenuHandler
; Create a submenu in the main menu
 MyMenu.Add "Submenu4", Submenu1


 MyMenu.Add                                               ; Add a separator line
 MyMenu.Add "Item 3333", MenuHandler                      ; Add a third menu item

 MyMenu.Default := "Item 1111"

; Global selected
MenuHandler(Item, ItemPos, MyMenu) {
	;MsgBox "You selected " Item " (position " ItemPos " in " MyMenu.Name ")"
	global selMenu:=MyMenu.Name, selPos:=ItemPos, selItem:=Item   ; Global varibles
}






;==================================================================================================
; Rock-click (Left-Mouse-Down + Right-Mouse-Click) run custom menu
;==================================================================================================

~LButton & RButton::      ; Left-Mouse-Down + Right-Mouse-Click
{

 if WinActive("ahk_class ThunderRT6FormDC")                          ; If in the XY window
 {
    ;MyMenu.Disable("Item 1111")

    MouseGetPos(&fX, &fY, &fID, &fWin)

    WinGetPos(&dX, &dY, &dW, &dH, "ahk_class ThunderRT6FormDC")

    If(fX > 300 && fX < dW-235 && fY > 100 && fY < dH-60) {          ; Hover area: 300 is the width of the tree and 235 is the width of the Catalog or Preview pane, 100 is the height above the column header and 60 is the height of the status bar
	   run ".\2.ahk"                                                 ; Display second menu after the XY menu displayed
	   run ".\3.ahk"                                                 ; Display third menu after the second menu displayed
	   run ".\4.ahk"                                                 ; Display fourth menu after the third menu displayed
       xyHwnd := GetxyHwnd()
	   Send_WM_COPYDATA(xyHwnd, '::`#1400')                          ; Send the script to XY (Display XY menu #1400)

	   if !WinExist("ahk_class #32768") {
	      ;MyMenu.Enable("Item 1111")
	      return
	   }
	   global IDLast := WinGetIDLast("ahk_class #32768")
       MouseGetPos , , &id                                           ; Automatically close another menu
	   sleep 100
       if(WinExist("ahk_class " IDLast) && WinGetProcessName(WinActivate("A")) == "XYplorer.exe")
	      WinClose "ahk_class " IDLast
	   else if(WinExist("ahk_id " IDLast) && WinGetClass("ahk_id " id) != "#32768")
	      WinClose "ahk_id " IDLast
	   else if(WinExist("ahk_id " IDLast) && id == IDLast)
	      WinClose "ahk_id " IDLast
	}
	else {
	   Send("{RButton}")                               ; Send key if not in the hover area
	}
    ;MyMenu.Enable("Item 1111")
 }


 if(!selItem)                                                        ; Return if no menu item is selected
	return






;==================================================================================================
; Perform different actions
;==================================================================================================

 switch selItem
 {
    case "Item 1111":
        if (xyHwnd := GetxyHwnd()) {                                                                                                           ; If xy is running
		    WinActivate("ahk_id " xyHwnd)                                                                                                      ; Active XY window
            Send_WM_COPYDATA(xyHwnd, '::msg "Hello!"')                           ; Send the script to XY
        } else {
            Run xyPath ' /feed=|::msg "Hello!"|'                                 ; If XY is not running, run XY and run the script
			WinWaitActive WinExist("ahk_class ThunderRT6FormDC")                                                                               ; Waiting to activate the window
			sleep 3000
			WinActivate("ahk_class ThunderRT6FormDC")
        }
    case "Item 2222":
	    MsgBox "You selected " selItem " (position " selPos " in " selMenu ")"
    case "Submenu item 1111":
	    MsgBox "You selected " selItem " (position " selPos " in " selMenu ")"
    case "Submenu item 2222":
	    MsgBox "You selected " selItem " (position " selPos " in " selMenu ")"
    case "Item 3333":
	    MsgBox "You selected " selItem " (position " selPos " in " selMenu ")"
    default:
		Msgbox "Hello!"
 }

 global selMenu:="", selPos:="", selItem:=""
 return

}






;==================================================================================================
; XYplorer Send and Get functions
;==================================================================================================

XY_Get(bAll:=false, bSelection:=false)
{
    xyQueryScript := '::if (!' bAll ' && !' bSelection ') {$return = "<curpath>"`;} elseif (' bAll ') {$return = listpane(, , , "<crlf>")`;} elseif (' bSelection ') {$return = get("selectedItemsPathNames", "<crlf>")`;} copydata ' G_OwnHWND ', "$return", 2`;'

    Send_WM_COPYDATA(xyHwnd := GetxyHwnd(), xyQueryScript)

    return dataReceived
}


GetxyHwnd() {
	static xyClass := 'ahk_class ThunderRT6FormDC'

	if hwnd := WinActive(xyClass)
		return hwnd
	else if WinExist(xyClass)
		return WinGetList(xyClass)[1]
}


Send_WM_COPYDATA(xyHwnd, message) {

   size := StrLen(message)
   if !(StrLen(Chr(0xFFFF))) {
      data := Buffer(size * 2, 0)
      StrPut(message, &data, size, "UTF-16")
   } else {
      data := message
   }

   COPYDATA := Buffer(A_PtrSize * 3)
   NumPut("Ptr", 4194305, COPYDATA, 0)
   NumPut("UInt", size * 2, COPYDATA, A_PtrSize)
   NumPut("Ptr", StrPtr(data), COPYDATA, A_PtrSize * 2)

   return DllCall("User32.dll\SendMessageW", "Ptr", xyHwnd, "UInt", 74, "Ptr", 0, "Ptr", COPYDATA, "Ptr")
}


Receive_WM_COPYDATA(wParam, lParam, *) {
	global dataReceived := StrGet(
		NumGet(lParam + 2 * A_PtrSize, 'Ptr'), ; COPYDATASTRUCT.lpData, ptr to a str presumably
		NumGet(lParam + A_PtrSize, 'UInt') / 2 ; COPYDATASTRUCT.cbData, count bytes of lpData, /2 to get count chars in unicode str
	)
}